
-- This is free software distributed under the terms of the GNU Public
-- License version 2 or higher.  Full text of the license is available
-- from the GNU Project: http://www.fsf.org/copyleft/gpl.html

create function inline_0 ()
returns integer as '

declare
  ds_id		portal_datasources.datasource_id%TYPE;
begin
  
  ds_id := portal_datasource__new(
    ''survey_portlet'',
    ''Displays surveys to take''
  );

  -- 4 defaults procs

  -- shadeable_p 
  perform portal_datasource__set_def_param (
	ds_id,
	''t'',
	''t'',
	''shadeable_p'',
	''t''
);	

  -- shaded_p 
  perform portal_datasource__set_def_param (
	ds_id,
	''t'',
	''t'',
	''shaded_p'',
	''f''
);	

  -- hideable_p 
  perform portal_datasource__set_def_param (
	ds_id,
	''t'',
	''t'',
	''hideable_p'',
	''t''
);

  -- user_editable_p 
  perform portal_datasource__set_def_param (
	ds_id,
	''t'',
	''t'',
	''user_editable_p'',
	''f''
);

  -- link_hideable_p 
  perform portal_datasource__set_def_param (
	ds_id,
	''t'',
	''t'',
	''link_hideable_p'',
	''t''
);

return 0;

end;' language 'plpgsql';

select inline_0();
drop function inline_0();


-- create the implementation
select acs_sc_impl__new (
	'portal_datasource',
	'survey_portlet',
	'survey_portlet'
);

-- add all the needed hooks for the implementation
select acs_sc_impl_alias__new (
       'portal_datasource',
       'survey_portlet',
       'GetMyName',
       'survey_portlet::get_my_name',
       'TCL'
);

select acs_sc_impl_alias__new (
       'portal_datasource',
       'survey_portlet',
       'GetPrettyName',
       'survey_portlet::get_pretty_name',
       'TCL'
);

select acs_sc_impl_alias__new (
       'portal_datasource',
       'survey_portlet',
       'Link',
       'survey_portlet::link',
       'TCL'
);

select acs_sc_impl_alias__new (
       'portal_datasource',
       'survey_portlet',
       'AddSelfToPage',
       'survey_portlet::add_self_to_page',
       'TCL'
);

select acs_sc_impl_alias__new (
       'portal_datasource',
       'survey_portlet',
       'Show',
       'survey_portlet::show',
       'TCL'
);

select acs_sc_impl_alias__new (
       'portal_datasource',
       'survey_portlet',
       'Edit',
       'survey_portlet::edit',
       'TCL'
);

select acs_sc_impl_alias__new (
       'portal_datasource',
       'survey_portlet',
       'RemoveSelfFromPage',
       'survey_portlet::remove_self_from_page',
       'TCL'
);

-- Add the binding
select acs_sc_binding__new (
    'portal_datasource',
    'survey_portlet'
);

